@echo off
SET _IDE_HOME=..\..
if not exist %_IDE_HOME%\lib\core.jar goto NO_IDE

set _IDE_USER=%USERPROFILE%\nbuser
copy %0 %_IDE_HOME%\writetest.%USERNAME% > nul 2> nul 
IF not exist %_IDE_HOME%\writetest.%USERNAME% goto READ_ONLY
del %_IDE_HOME%\writetest.%USERNAME%

echo Warning : You are running the IDE in multiuser mode with write 
echo permissions to the shared installation directory. Do not use AutoUpdate
echo from this session, it will not work and may cause problems. If you don't
echo want to continue, press Ctrl-C.
pause

:READ_ONLY
IF exist "%_IDE_USER%\system" goto USER_EXIST
echo User directory does not exist...
echo Setting up this user for the IDE...
mkdir "%_IDE_USER%"
xcopy /e "%_IDE_HOME%\Development" "%_IDE_USER%\Development\" > nul
mkdir "%_IDE_USER%\system"
mkdir "%_IDE_USER%\modules"
mkdir "%_IDE_USER%\lib"
mkdir "%_IDE_USER%\lib\ext"
mkdir "%_IDE_USER%\lib\patches"
mkdir "%_IDE_USER%\Projects"
echo. > "%_IDE_USER%\system\project.last_hidden"
echo. > "%_IDE_USER%\system\project.basic_hidden"
echo. > "%_IDE_USER%\system\Projects\workspace.ser_hidden"
goto END_USER
:USER_EXIST
echo Using %_IDE_USER% as user directory...
:END_USER

:CHECK_ENV
rem JAVA_PATH may or may not be already set as
rem an environment variable.  If it is, use the
rem existing setting, if not set, user must set it

if %JAVA_PATH%. == . goto SET_JAVA
GOTO RUN

:SET_JAVA
SET JAVA_PATH=S:\Software\jdk12

:RUN
rem Variables need to have been set,
rem manually or outside this script -
rem check that they have been

if %JAVA_PATH%. == . goto NO_JAVA

rem Everything seems to be OK, lets go ...
:RESTART

SET EX_PATH=
SET PATCH_PATH=

IF not exist "%_IDE_USER%\lib\patches" goto NO_USER_PATCH

FOR %%f IN ( "%_IDE_USER%\lib\patches\*.zip" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" patch
FOR %%f IN ( "%_IDE_USER%\lib\patches\*.jar" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" patch

:NO_USER_PATCH

IF not exist "%_IDE_HOME%\lib\patches" goto NO_PATCH

FOR %%f IN ( "%_IDE_HOME%\lib\patches\*.zip" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" patch
FOR %%f IN ( "%_IDE_HOME%\lib\patches\*.jar" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" patch

:NO_PATCH

IF not exist "%_IDE_USER%\lib\ext" goto NO_USER_EXT

FOR %%f IN ( "%_IDE_USER%\lib\ext\*.zip" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" ext
FOR %%f IN ( "%_IDE_USER%\lib\ext\*.jar" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" ext

:NO_USER_EXT

IF not exist "%_IDE_HOME%\lib\ext" goto NO_EXT

FOR %%f IN ( "%_IDE_HOME%\lib\ext\*.zip" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" ext
FOR %%f IN ( "%_IDE_HOME%\lib\ext\*.jar" ) DO CALL %_IDE_HOME%\bin\oldlauncher\add2path.bat "%%f" ext

:NO_EXT

SET IDE_CLASSPATH=%PATCH_PATH%;%_IDE_HOME%\lib\core.jar;%_IDE_HOME%\lib\openide.jar;%JAVA_PATH%\jre\lib\i18n.jar;%JAVA_PATH%\lib\tools.jar;%JAVA_PATH%\lib\dt.jar;%EX_PATH%

%JAVA_PATH%\bin\java -classpath %IDE_CLASSPATH% -Dnetbeans.debug.exceptions=true -Djava.security.policy=%_IDE_HOME%\bin\ide.policy -Dnetbeans.home=%_IDE_HOME% -Dnetbeans.user="%_IDE_USER%" -Xmx96m org.netbeans.Main

if errorlevel 67 goto END
if errorlevel 66 goto UPDATE

goto END

:UPDATE
%JAVA_PATH%\bin\java -classpath %_IDE_HOME%\lib\updater.jar -Dnetbeans.home=%_IDE_HOME% -Dnetbeans.user="%_IDE_USER%" org.netbeans.updater.UpdaterFrame
goto RESTART

:NO_IDE
echo Error: _IDE_HOME variable does not point to your
echo IDE installation. Please edit your startup script. 
pause
goto END

:NO_JAVA
echo Error: JAVA_PATH variable does not point to a Java 2
echo installation. Please edit your startup script.  
pause
goto END

:END
